/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (II)        *
 *            - OtBbNEƎ\[XE{EʐM -             *
 *                                                                     *
 *      Copyright 1995,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

typedef struct {  /* (Res1) \[Xli[\̂̒` */
    Boolean  input_by_mm;  /* ͂̒P: True => mm, False => C` */
    XmString mm_label;     /* "~[g" Pʂ̃x */
    XmString inch_label;   /* "C`" Pʂ̃x */
} CustomRec, *CustomPtr;

static XtResource res[] = {  /* (Res2) \[X`\̂̔z */
  {"inputByMm", "InputByMm", XtRBoolean,
   sizeof(Boolean), XtOffsetOf(CustomRec, input_by_mm), XtRString, "True"},
  {"mmLabel", "MmLabel", XmRXmString,
   sizeof(XmString), XtOffsetOf(CustomRec, mm_label), XtRString, "mm"},
  {"inchLabel", "InchLabel", XmRXmString,
   sizeof(XmString), XtOffsetOf(CustomRec, inch_label), XtRString, "inch"},
};

static XrmOptionDescRec opt[] = {  /* (Opt1) ƎIvV̒` */
    {"-mm",   "*inputByMm", XrmoptionNoArg, "True"},  /* ͒Pʂ mm */
    {"-inch", "*inputByMm", XrmoptionNoArg, "False"}, /* ͒Pʂ C` */
};

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, text, label;
    Arg    al[20];
    int    ac;
    CustomRec data;  /* \[Xli[\̂p */

    XtSetLanguageProc(NULL, NULL, NULL);
                                /* (Opt2) ƎIvV̒`ƌn */
    ac = 0;                                            /*             */
    toplevel = XtAppInitialize(&app_context, "Inputunit", opt, XtNumber(opt),
                               &argc, argv, NULL, al, ac);
    /* (Res3) \[Xl̎o */
    XtGetApplicationResources(toplevel, &data, res, XtNumber(res), NULL, 0);

    ac = 0;
    XtSetArg(al[ac], XmNorientation, XmHORIZONTAL); ac++;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);
    ac = 0;
    text = XmCreateTextField(panel, "text", al, ac);
    XtManageChild(text);

    ac = 0;
    if (data.input_by_mm) {
        XtSetArg(al[ac], XmNlabelString, data.mm_label); ac++;
    } else {
        XtSetArg(al[ac], XmNlabelString, data.inch_label); ac++;
    }
    label = XmCreateLabel(panel, "label", al, ac);
    XtManageChild(label);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
