/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (II)        *
 *            - OtBbNEƎ\[XE{EʐM -             *
 *                                                                     *
 *      Copyright 1995,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static GC gc;
static Colormap colormap;
static unsigned long planes[1], pixels[4];

/* }EX̑쎞ɌĂяoCxgEnh */
static void DrawEH(w, client_data, event, dispatch)
    Widget     w;
    XtPointer  client_data;
    XEvent    *event;
    Boolean   *dispatch;
{
    static int x0, y0;  /* ̎n_W */
    static int x1, y1;  /* ̏I_W */
    static unsigned long color;  /* ŏIIȐ̐F */

    switch (event->type) {
    case ButtonPress:
    /* o[oh`̊Jn */
        /* n_̍WZbg */
        x0 = x1 = event->xbutton.x;
        y0 = y1 = event->xbutton.y;
        /* GC o[ohpɐݒ */
        XSetFunction(XtDisplay(w), gc, GXxor);
        XSetPlaneMask(XtDisplay(w), gc, planes[0]);
        XSetForeground(XtDisplay(w), gc, planes[0]);
        XSetLineAttributes(XtDisplay(w), gc, 2, LineOnOffDash, CapButt, JoinMiter);
        /* ŏ̃o[oh` */
        XDrawLine(XtDisplay(w), XtWindow(w), gc, x0, y0, x1, y1);
        /* {^ԍɂčŏI}`̐Fς (o[oh͉) */
        switch (event->xbutton.button) {
            case Button1: color = pixels[0]; break;
            case Button2: color = pixels[1]; break;
            case Button3: color = pixels[2]; break;
        }
        break;
    case MotionNotify:
    /* o[ohŕ` */
        /* Õo[oh߁Cxʒuɕ` */
        XDrawLine(XtDisplay(w), XtWindow(w), gc, x0, y0, x1, y1);
        /* ݂̃|C^̈ʒuC̏I_ɃZbg */
        x1 = event->xbutton.x;
        y1 = event->xbutton.y;
        /* n_猻݂̃|C^̈ʒu܂Ńo[oh` */
        XDrawLine(XtDisplay(w), XtWindow(w), gc, x0, y0, x1, y1);
        break;
    case ButtonRelease:
    /* ŏIʂ𐳂Fŕ` */
        /* Õo[oh߁Cxʒuɕ` */
        XDrawLine(XtDisplay(w), XtWindow(w), gc, x0, y0, x1, y1);
        /* ݂̃|C^̈ʒuC̏I_ɃZbg */
        x1 = event->xmotion.x;
        y1 = event->xmotion.y;
        /* GC 𕁒ʂɖ߂ */
        XSetFunction(XtDisplay(w), gc, GXcopy);
        XSetPlaneMask(XtDisplay(w), gc, AllPlanes);
        XSetLineAttributes(XtDisplay(w), gc, 2, LineSolid, CapButt, JoinMiter);
        /* {^ԍɍFZbg */
        XSetForeground(XtDisplay(w), gc, color);
        /* ŏIʂƂāCn_猻݂̃|C^̈ʒu܂Ő` */
        XDrawLine(XtDisplay(w), XtWindow(w), gc, x0, y0, x1, y1);
        break;
    }
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, canvas;
    Arg al[20];
    int ac;
    int flags = DoRed | DoGreen | DoBlue;
    Display *display;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Rubberband", NULL, 0,
                               &argc, argv, NULL, al, ac);
    ac = 0;
    panel = XmCreateForm(toplevel, "panel", al, ac);
    XtManageChild(panel);

    ac = 0;
    canvas = XmCreateDrawingArea(panel, "canvas", al, ac);
    XtManageChild(canvas);

    /* }EX̃CxgEnho^ */
    XtAddEventHandler(canvas,
              ButtonPressMask | ButtonReleaseMask | ButtonMotionMask, False,
              DrawEH, NULL);

    XtRealizeWidget(toplevel);

    /* OtBbNEReLXg𐶐 */
    gc = XCreateGC(XtDisplay(canvas), XtWindow(canvas), NULL, NULL);

    /* ftHg̃J[}bv𓾂 */
    colormap = DefaultColormapOfScreen(XtScreen(canvas));

    /* o[ohpɃJ[Zt (4FC1v[}XN) */
    if (XAllocColorCells(XtDisplay(canvas), colormap,
                         False, planes, 1, pixels, 4) == 0) {
        fprintf(stderr, "Cannot allocate color cells.\n");
        exit(1);
    }

    display = XtDisplay(canvas);
    /* ŏIIȕ`p̐Ft */
    XStoreNamedColor(display, colormap, "red", pixels[0], flags);
    XStoreNamedColor(display, colormap, "blue", pixels[1], flags);
    XStoreNamedColor(display, colormap, "green", pixels[2], flags);
    /* h[GA̔wi̐Ft */
    XStoreNamedColor(display, colormap, "white", pixels[3], flags);

    /* o[ohp̐Ft */
    XStoreNamedColor(display, colormap, "yellow3", pixels[0] | planes[0], flags);
    XStoreNamedColor(display, colormap, "yellow3", pixels[1] | planes[0], flags);
    XStoreNamedColor(display, colormap, "yellow3", pixels[2] | planes[0], flags);
    XStoreNamedColor(display, colormap, "yellow3", pixels[3] | planes[0], flags);

    /* h[GA̔wiF𔒂ɐݒ肵Ă */
    XtVaSetValues(canvas, XmNbackground, pixels[3], NULL);

    XtAppMainLoop(app_context);
}
