/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (II)        *
 *            - OtBbNEƎ\[XE{EʐM -             *
 *                                                                     *
 *      Copyright 1995,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void OpenCB(), SaveCB();
static Widget toplevel, text;
static Atom xa_wm_delete;

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget panel, field, label, fname, open, save;
    Arg al[20];
    int ac;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Closesave", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateForm(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* t@C͂ăI[v̈ */
    ac = 0;
    field = XmCreateRowColumn(panel, "field", al, ac);
    XtManageChild(field);
    /* "t@C: */
    ac = 0;
    label = XmCreateLabel(field, "label", al, ac);
    XtManageChild(label);
    /* ͗̈ */
    ac = 0;
    fname = XmCreateTextField(field, "fname", al, ac);
    XtManageChild(fname);
    /* [I[v] */
    ac = 0;
    open = XmCreatePushButton(field, "open", al, ac);
    XtAddCallback(open, XmNactivateCallback, OpenCB, fname);
    XtManageChild(open);
    /* [ۑ] */
    ac = 0;
    save = XmCreatePushButton(field, "save", al, ac);
    XtAddCallback(save, XmNactivateCallback, SaveCB, fname);
    XtManageChild(save);

    /* t@C̓e\̈ */
    ac = 0;
    text = XmCreateScrolledText(panel, "text", al, ac);
    XtManageChild(text);
    XtVaSetValues(XtParent(text), XmNtopWidget, field, NULL);

    /* (1) "WM_DELETE_WINDOW" ̃Ag𐶐 */
    xa_wm_delete = XmInternAtom(XtDisplay(toplevel), "WM_DELETE_WINDOW", False);

    /* (2) "WM_DELETE_WINDOW" p̃vgRER[obNo^ */
    XmAddWMProtocolCallback(toplevel, xa_wm_delete, SaveCB, fname);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

/* [I[v] {^̃R[obN */
static void OpenCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget textf = (Widget)client_data;
    char *filename;
    FILE *fp;
    char buff[BUFSIZ];

    /* ͂ꂽt@Co */
    XtVaGetValues(textf, XmNvalue, &filename, NULL);

    /* t@C̓eeLXgɕ\ */
    if ((fp = fopen(filename, "r")) != NULL) {  /* t@CI[v */
        XmTextSetString(text, "");  /* eLXg̓e */
        while (fgets(buff, BUFSIZ, fp) != NULL)
            XmTextInsert(text, XmTextGetLastPosition(text), buff); /* ǉ */
        fclose(fp);
    }

    XtFree(filename);
}

/* [ۑ] {^̃R[obN */
/* (3) EBhEEj[ "Close" {^ꂽƂĂяo */
static void SaveCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    XmAnyCallbackStruct *cb = (XmAnyCallbackStruct *)call_data;
    Widget textf = (Widget)client_data;
    char *filename;
    char *string;
    FILE *fp;

    /* (4) gbvxȊO "Close" {^ꂽƂ͉Ȃ */
    if (cb->reason == XmCR_WM_PROTOCOLS &&  /* EBhEE}l[W炩H */
         cb->event->type == ClientMessage &&  /* NCAgEbZ[WH */
          cb->event->xclient.data.l[0] == xa_wm_delete &&  /* "Close" H */
           w != toplevel)  /* gbvxH */
        return;

    /* ͂ꂽt@Co */
    XtVaGetValues(textf, XmNvalue, &filename, NULL);

    /* eLXg̓eo */
    string = XmTextGetString(text);

    /* eLXg̓et@Cɏo */
    if ((fp = fopen(filename, "w")) != NULL) {  /* t@CI[v */
        fputs(string, fp);
        fclose(fp);
    }

    XtFree(filename);
    XtFree(string);
}
